package dev.shadowsoffire.apotheosis.adventure.socket;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.socket.SocketHelper;
import net.minecraft.core.RegistryAccess;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.Container;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.crafting.RecipeSerializer;
import net.minecraft.world.level.Level;

public class AddSocketsRecipe extends AdventureModule.ApothSmithingRecipe {
  private final Ingredient input;
  
  private final int maxSockets;
  
  public AddSocketsRecipe(ResourceLocation id, Ingredient input, int maxSockets) {
    super(id, Ingredient.f_43901_, input, ItemStack.f_41583_);
    this.input = input;
    this.maxSockets = maxSockets;
  }
  
  public boolean m_5818_(Container pInv, Level level) {
    ItemStack in = pInv.m_8020_(1);
    return (!LootCategory.forItem(in).isNone() && SocketHelper.getSockets(in) < getMaxSockets() && getInput().test(pInv.m_8020_(2)));
  }
  
  public ItemStack m_5874_(Container pInv, RegistryAccess regs) {
    ItemStack out = pInv.m_8020_(1).m_41777_();
    if (out.m_41619_())
      return ItemStack.f_41583_; 
    int sockets = SocketHelper.getSockets(out) + 1;
    SocketHelper.setSockets(out, sockets);
    return out;
  }
  
  public RecipeSerializer<?> m_7707_() {
    return (RecipeSerializer<?>)Serializer.INSTANCE;
  }
  
  public boolean m_5598_() {
    return true;
  }
  
  public Ingredient getInput() {
    return this.input;
  }
  
  public int getMaxSockets() {
    return this.maxSockets;
  }
}
